local CCBabble  = AceLibrary("Babble-Spell-2.2")
local CCLocale  = AceLibrary("AceLocale-2.2"):new("CCBreaker")



CCBreaker:RegisterDefaults("char",{
    showon = {
        player = false,
        party = false,
        raid = false,
        pet = false,
        partypet = false,
        raidpet = false,
        others = true,
    },
    showfrom = {
        player = true,
        party = true,
        raid = true,
        pet = true,
        partypet = true,
        raidpet = true,
        others = false,
    },
    showeffects = {
        freezingtrap = true,
        hibernate = true,
        polymorph = true,
        shackleundead = true,
        sap = true,
    },
    display = {
        fubar = {
            spell = true,
            target = false,
            breaker = true,
            ability = false,
        },
        text = {
            colors = true,   
            console = true,
            center = false,
        }
    },
})

-- Menu

CCBreaker.OnMenuRequest = {
    type = "group",
    args = {
        reset = {
            type = "execute",
            name = CCLocale["reset"],
            desc = CCLocale["reset breaker data"],
            func = "reset",
        },
        display = {
            type = "group",
            name = CCLocale["Display"],
            desc = CCLocale["Display options"],
            args = {
                console ={
                    type = "group",
                    name = CCLocale["Console"],
                    desc = CCLocale["Display options in console"],
                    args = {
                        colors = {
                            type = "toggle",
                            name = CCLocale["Colors"],
                            desc = CCLocale["Color messages"],
                            get = function() return CCBreaker.db.char.display.text.colors end,
                            set = function(v) CCBreaker.db.char.display.text.colors = v end,
                        },
                        console = {
                            type = "toggle",
                            name = CCLocale["Console"],
                            desc = CCLocale["Display console messages"],
                            get = function() return CCBreaker.db.char.display.text.console end,
                            set = function(v) CCBreaker.db.char.display.text.console = v end,
                        },
                        center = {
                            type = "toggle",
                            name = CCLocale["Center"],
                            desc = CCLocale["Display centered messages"],
                            get = function() return CCBreaker.db.char.display.text.center end,
                            set = function(v) CCBreaker.db.char.display.text.center = v end,
                        },
                    },
                },
                fubar = {
                    type = "group",
                    name = CCLocale["FuBar"],
                    desc = CCLocale["Display options in Fubar"],
                    args = {
                        spell = {
                            type = "toggle",
                            name = CCLocale["Spell"],
                            desc = CCLocale["display broken spell"],
                            get = function() return CCBreaker.db.char.display.fubar.spell end,
                            set = function(v) CCBreaker.db.char.display.fubar.spell = v end,
                        },
                        target = {
                            type = "toggle",
                            name = CCLocale["Target"],
                            desc = CCLocale["display freed target"],
                            get = function() return CCBreaker.db.char.display.fubar.target end,
                            set = function(v) CCBreaker.db.char.display.fubar.target = v end,
                        },
                        breaker = {
                            type = "toggle",
                            name = CCLocale["Breaker"],
                            desc = CCLocale["display who broke CC"],
                            get = function() return CCBreaker.db.char.display.fubar.breaker end,
                            set = function(v) CCBreaker.db.char.display.fubar.breaker = v end,
                        },
                        ability = {
                            type = "toggle",
                            name = CCLocale["Ability"],
                            desc = CCLocale["display ability breaking the CC"],
                            get = function() return CCBreaker.db.char.display.fubar.ability end,
                            set = function(v) CCBreaker.db.char.display.fubar.ability = v end,
                        },
                    },
                },
            },
        },
        filter = {
            type = "group",
            name = CCLocale["Filter"],
            desc = CCLocale["Filter Options"],
            args = {
                showon = {
                    type = "group",
                    name = CCLocale["show on"],
                    desc = CCLocale["report CC breaks to those targets only"],
                    args = {
                        player = {
                            type = "toggle",
                            name = CCLocale["player"],
                            desc = CCLocale["Show break on player"],
                            get = function() return CCBreaker.db.char.showon.player end,
                            set = function(v) CCBreaker.db.char.showon.player = v end,
                        },
                        party = {
                            type = "toggle",
                            name = CCLocale["party"],
                            desc = CCLocale["Show break on party members"],
                            get = function() return CCBreaker.db.char.showon.party end,
                            set = function(v) CCBreaker.db.char.showon.party = v end,
                        },
                        raid = {
                            type = "toggle",
                            name = CCLocale["raid"],
                            desc = CCLocale["Show break on raid members"],
                            get = function() return CCBreaker.db.char.showon.raid end,
                            set = function(v) CCBreaker.db.char.showon.raid = v end,
                        },
                        pet = {
                            type = "toggle",
                            name = CCLocale["pet"],
                            desc = CCLocale["Show break on your pet"],
                            get = function() return CCBreaker.db.char.showon.pet end,
                            set = function(v) CCBreaker.db.char.showon.pet = v end,
                        },
                        partypet = {
                            type = "toggle",
                            name = CCLocale["party pet"],
                            desc = CCLocale["Show break on party pets"],
                            get = function() return CCBreaker.db.char.showon.partypet end,
                            set = function(v) CCBreaker.db.char.showon.partypet = v end,
                        },
                        raidpet = {
                            type = "toggle",
                            name = CCLocale["raid pet"],
                            desc = CCLocale["Show break on raid pets"],
                            get = function() return CCBreaker.db.char.showon.raidpet end,
                            set = function(v) CCBreaker.db.char.showon.raidpet = v end,
                        },
                        others = {
                            type = "toggle",
                            name = CCLocale["others"],
                            desc = CCLocale["Show break on others"],
                            get = function() return CCBreaker.db.char.showon.others end,
                            set = function(v) CCBreaker.db.char.showon.others = v end,
                        },
                    },
            }, 
                showfrom = {
                    type = "group",
                    name = CCLocale["show from"],
                    desc = CCLocale["report CC breaks from those only"],
                    args = {
                        player = {
                            type = "toggle",
                            name = CCLocale["player"],
                            desc = CCLocale["Show break from player"],
                            get = function() return CCBreaker.db.char.showfrom.player end,
                            set = function(v) CCBreaker.db.char.showfrom.player = v end,
                        },
                        party = {
                            type = "toggle",
                            name = CCLocale["party"],
                            desc = CCLocale["Show break from party members"],
                            get = function() return CCBreaker.db.char.showfrom.party end,
                            set = function(v) CCBreaker.db.char.showfrom.party = v end,
                        },
                        raid = {
                            type = "toggle",
                            name = CCLocale["raid"],
                            desc = CCLocale["Show break from raid members"],
                            get = function() return CCBreaker.db.char.showfrom.raid end,
                            set = function(v) CCBreaker.db.char.showfrom.raid = v end,
                        },
                        pet = {
                            type = "toggle",
                            name = CCLocale["pet"],
                            desc = CCLocale["Show break from your pet"],
                            get = function() return CCBreaker.db.char.showfrom.pet end,
                            set = function(v) CCBreaker.db.char.showfrom.pet = v end,
                        },
                        partypet = {
                            type = "toggle",
                            name = CCLocale["party pet"],
                            desc = CCLocale["Show break from party pets"],
                            get = function() return CCBreaker.db.char.showfrom.partypet end,
                            set = function(v) CCBreaker.db.char.showfrom.partypet = v end,
                        },
                        raidpet = {
                            type = "toggle",
                            name = CCLocale["raid pet"],
                            desc = CCLocale["Show break on raid pets"],
                            get = function() return CCBreaker.db.char.showfrom.raidpet end,
                            set = function(v) CCBreaker.db.char.showfrom.raidpet = v end,
                        },
                        others = {
                            type = "toggle",
                            name = CCLocale["others"],
                            desc = CCLocale["Show break from others"],
                            get = function() return CCBreaker.db.char.showfrom.others end,
                            set = function(v) CCBreaker.db.char.showfrom.others = v end,
                        },  
                    }, 
                },
                showeffects = {
                    type = "group",
                    name = CCLocale["show effects"],
                    desc = CCLocale["report CC breaks of effects"],
                    args = {
                        freezingtrap = {
                            type = "toggle",
                            name = CCBabble["Freezing Trap"],
                            desc = string.gsub(CCLocale["Show break of §s"],"§s",CCBabble["Freezing Trap"]),
                            get = function() return CCBreaker.db.char.showeffects.freezingtrap end,
                            set = function(v) CCBreaker.db.char.showeffects.freezingtrap = v end,
                        },
                        hibernate = {
                            type = "toggle",
                            name = CCBabble["Hibernate"],
                            desc = string.gsub(CCLocale["Show break of §s"],"§s",CCBabble["Hibernate"]),
                            get = function() return CCBreaker.db.char.showeffects.hibernate end,
                            set = function(v) CCBreaker.db.char.showeffects.hibernate = v end,
                        },
                        polymorph = {
                            type = "toggle",
                            name = CCBabble["Polymorph"],
                            desc = string.gsub(CCLocale["Show break of §s"],"§s",CCBabble["Polymorph"]..", "
                                ..CCBabble["Polymorph: Pig"].." and "
                                ..CCBabble["Polymorph: Turtle"]),
                            get = function() return CCBreaker.db.char.showeffects.polymorph end,
                            set = function(v) CCBreaker.db.char.showeffects.polymorph = v end,
                        },
                        sap = {
                            type = "toggle",
                            name = CCBabble["Sap"],
                            desc = string.gsub(CCLocale["Show break of §s"],"§s",CCBabble["Sap"]),
                            get = function() return CCBreaker.db.char.showeffects.sap end,
                            set = function(v) CCBreaker.db.char.showeffects.sap = v end,
                        },
                        shackleundead = {
                            type = "toggle",
                            name = CCBabble["Shackle Undead"],
                            desc = string.gsub(CCLocale["Show break of §s"],"§s",CCBabble["Shackle Undead"]),
                            get = function() return CCBreaker.db.char.showeffects.shackleundead end,
                            set = function(v) CCBreaker.db.char.showeffects.shackleundead = v end,
                        },
                    }, 
                },
            },
        },
    },
}

function CCBreaker:reset()
    self.lastinfo = nil
    self:recyclebreakertable()
    self:UpdateText()
end

CCBreaker:RegisterChatCommand(CCLocale["Slash-Commands"],CCBreaker.OnMenuRequest)




